unit FrmAppointmentIODialog;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls, TimePeriod;

type
TFrmAppointmentIODlg = class(TForm)
   OKBtn: TButton;
   CancelBtn: TButton;
   Bevel1: TBevel;
   Label1: TLabel;
   Label2: TLabel;
   Label3: TLabel;
   EditStartDate: TEdit;
   EditEndDate: TEdit;
   EditDisplayStr: TEdit;
   Label4: TLabel;
   Label5: TLabel;
   EditStartTime: TEdit;
   EditEndTime: TEdit;
    procedure OKBtnClick(Sender: TObject);
private
   m_TApp : TTimePeriod;

   function  Init(aApp: TTimePeriod): Boolean;
   procedure Deinit;
   
   function  GetData: Boolean;
   function  GetDate(aEdit:TEdit): Boolean;
   function  GetTime(aEdit:TEdit): Boolean;
   
public
   function Execute(aApp: TTimePeriod): Boolean;
   

end;
{**************************************************************************************************}
var
  FrmAppointmentIODlg: TFrmAppointmentIODlg;

implementation
Uses Dialogs;
{$R *.DFM}
{**************************************************************************************************}
{* Eigene Funktionen                                                                              *}
{**************************************************************************************************}
function  TFrmAppointmentIODlg.Execute(aApp: TTimePeriod): Boolean;
begin
   Result := FALSE;
   If(Init(aApp)) then
      Result := (ShowModal = mrOk);
   Deinit;
end;
{**************************************************************************************************}
function  TFrmAppointmentIODlg.Init(aApp: TTimePeriod): Boolean;
begin
   try
      Result := Assigned(aApp);
      if(Result) then begin
         m_TApp := aApp;
         EditStartDate.Text := FormatDateTime('dd.mm.yyyy',aApp.StartDate);
         EditStartTime.Text := FormatDateTime('hh:nn:ss'  ,aApp.StartDate);

         EditEndDate.Text := FormatDateTime('dd.mm.yyyy',aApp.EndDate);
         EditEndTime.Text := FormatDateTime('hh:nn:ss'  ,aApp.EndDate);
         EditDisplayStr.Text := aApp.DisplayString;
      end;

   except
      on E:Exception do begin
         Result := FALSE;
         MessageDlg('Error while initilizing appointment dialog.'+#13+#10+E.Message, mtInformation, [mbOk], 0);
      end;
   end;
end;
{**************************************************************************************************}
procedure TFrmAppointmentIODlg.Deinit;
begin
   m_TApp := NIL;
end;
{**************************************************************************************************}
function TFrmAppointmentIODlg.GetData: Boolean;
begin
   // check input.
   Result := GetDate(EditStartDate);
   if(Result) then
      GetTime(EditStartTime);
   if(Result) then
      GetDate(EditEndDate);
   if(Result) then
      GetTime(EditEndTime);

   if(Result) then begin
      m_TApp.StartDate := StrToDate(EditStartDate.Text) + StrToTime(EditStartTime.Text);
      m_TApp.EndDate   := StrToDate(EditEndDate.Text)   + StrToTime(EditEndTime.Text  );
      m_TApp.DisplayString := EditDisplayStr.Text;
   end;
end;
{**************************************************************************************************}
function TFrmAppointmentIODlg.GetDate(aEdit:TEdit): Boolean;
begin
   try
      StrToDate(aEdit.Text);
      Result := (aEdit.Text <> '');
   except
      Result := FALSE;
      aEdit.SetFocus;
      MessageDlg('Wrong date format or field blank.', mtError, [mbOk] ,0);
   end;
end;
{**************************************************************************************************}
function  TFrmAppointmentIODlg.GetTime(aEdit:TEdit): Boolean;
begin
   try
      StrToTime(aEdit.Text);
      Result := (aEdit.Text <> '');
   except
      Result := FALSE;
      aEdit.SetFocus;
      MessageDlg('Wrong time format or field blank.', mtError, [mbOk] ,0);
   end;
end;
{**************************************************************************************************}
{**************************************************************************************************}
{* Eigene Funktionen (ENDE)                                                                       *}
{**************************************************************************************************}
procedure TFrmAppointmentIODlg.OKBtnClick(Sender: TObject);
begin
   ModalResult := mrNone;
   if(GetData) then
     ModalResult := mrOk;
end;
{**************************************************************************************************}
end.
