unit WeekBlockView;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, DsgnIntf, BlockWeekPeriod,
  Grids, StdCtrls, ComCtrls, Tabnotbk, Menus, TimePeriodList;

type
{**************************************************************************************************}
TFrmBlockWeekView = class(TForm)
    OkBtn: TButton;
    CancelBtn: TButton;
    AddBtn: TButton;
    EditBtn: TButton;
    DelBtn: TButton;
    PopupMenu1: TPopupMenu;
    Add1: TMenuItem;
    Edit1: TMenuItem;
    Delete1: TMenuItem;
    Book: TPageControl;
    T1: TTabSheet;
    T2: TTabSheet;
    T3: TTabSheet;
    T4: TTabSheet;
    T5: TTabSheet;
    T6: TTabSheet;
    T7: TTabSheet;
    Grid1: TStringGrid;
    Grid2: TStringGrid;
    Grid3: TStringGrid;
    Grid4: TStringGrid;
    Grid5: TStringGrid;
    Grid6: TStringGrid;
    Grid7: TStringGrid;
    procedure AddBtnClick(Sender: TObject);
    procedure EditBtnClick(Sender: TObject);
    procedure DelBtnClick(Sender: TObject);
    procedure Add1Click(Sender: TObject);
    procedure Edit1Click(Sender: TObject);
    procedure Delete1Click(Sender: TObject);
    procedure Grid6DblClick(Sender: TObject);
    procedure Grid1DblClick(Sender: TObject);
    procedure Grid2DblClick(Sender: TObject);
    procedure Grid3DblClick(Sender: TObject);
    procedure Grid4DblClick(Sender: TObject);
    procedure Grid5DblClick(Sender: TObject);
    procedure Grid7DblClick(Sender: TObject);
private
   m_TBlockWeekPeriod: TBlockWeekPeriod;

   function  Init(aList : TBlockWeekPeriod): Boolean;
   procedure Deinit;

   procedure DisplayListsInGrid ;
   procedure DeleteListsFromGrid;
   procedure UpdateListsInGrid  ;
   function  GetCurGrid: TStringGrid;
   function  GetCurList: TTimePeriodList;

   procedure DoNew;
   procedure DoEdit;
   procedure DoDelete;
public
   function Execute(aList: TBlockWeekPeriod): Boolean;
end;

var
  FrmBlockWeekView: TFrmBlockWeekView;
{**************************************************************************************************}
implementation
Uses Plan             , 
     TimePeriod       ,
     Utils            ,
     FrmWeekBlockIODlg;
{$R *.DFM}
{**************************************************************************************************}
function  TFrmBlockWeekView.Execute(aList: TBlockWeekPeriod): Boolean;
begin
   Result := FALSE;
   if(Init(aList)) then
      Result := (ShowModal = mrOk);
   Deinit;
end;
{**************************************************************************************************}
function  TFrmBlockWeekView.Init(aList : TBlockWeekPeriod): Boolean;
begin
   try
      Result := Assigned(aList);
      if(Result) then begin
         m_TBlockWeekPeriod:= aList;
         Book.ActivePage := T1;
         DisplayListsInGrid;
      end;
   except
      on E:Exception do begin
         Result := FALSE;
         MessageDlg('Error while initilizing property dialog.'+#13+#10+E.Message, mtError, [mbOk] ,0);
      end;
   end;
end;
{**************************************************************************************************}
procedure TFrmBlockWeekView.Deinit;
begin
   m_TBlockWeekPeriod:=NIL
end;
{**************************************************************************************************}
procedure TFrmBlockWeekView.DisplayListsInGrid ;

   procedure DisplayGrid(aGrid: TStringGrid; nLstNo: integer);
   var
      aItem     : TTimePeriod;
      nCounter  : integer    ;
      aList     : TTimePeriodList;
   begin
      aList := m_TBlockWeekPeriod.Blockings[nLstNo];
      aGrid.Cells[0,0] := 'Start:';
      aGrid.Cells[1,0] := 'End:';
      aGrid.Cells[2,0] := 'Display string:';
      aGrid.RowCount := lnMax(aList.Count+1 ,2);

      for nCounter := 0 to aList.Count - 1 do begin
         aItem := aList.Items[nCounter];
         if(Assigned(aItem)) then begin
            aGrid.Cells[0,nCounter+1] := TimeToStr(aItem.StartDate);
            aGrid.Cells[1,nCounter+1] := TimeToStr(aItem.EndDate  );
            aGrid.Cells[2,nCounter+1] := aItem.DisplayString
         end;
      end;
   end;
   
begin
   DisplayGrid(Grid1, 2);
   DisplayGrid(Grid2, 3);
   DisplayGrid(Grid3, 4);
   DisplayGrid(Grid4, 5);
   DisplayGrid(Grid5, 6);
   DisplayGrid(Grid6, 7);
   DisplayGrid(Grid7, 1);
end;
{**************************************************************************************************}
procedure TFrmBlockWeekView.DeleteListsFromGrid;

   procedure DeleteListFromGrid(aGrid: TStringGrid);
   var
     nCounter: integer;
   begin
      for nCounter := 0 to aGrid.RowCount-1 do 
         aGrid.Rows[nCounter].Clear;
   end;
   
begin
   DeleteListFromGrid(Grid1);
   DeleteListFromGrid(Grid2);
   DeleteListFromGrid(Grid3);
   DeleteListFromGrid(Grid4);
   DeleteListFromGrid(Grid5);
   DeleteListFromGrid(Grid6);
   DeleteListFromGrid(Grid7);
end;
{**************************************************************************************************}
procedure TFrmBlockWeekView.UpdateListsInGrid  ;
begin
   DeleteListsFromGrid;
   DisplayListsInGrid;
end;
{**************************************************************************************************}
function  TFrmBlockWeekView.GetCurGrid: TStringGrid;
begin
   Result := NIL;
   
   if(Book.ActivePage = T1) then
      Result := Grid1;

   if(Book.ActivePage = T2) then
      Result := Grid2;
      
   if(Book.ActivePage = T3) then
      Result := Grid3;
      
   if(Book.ActivePage = T4) then
      Result := Grid4;
      
   if(Book.ActivePage = T5) then
      Result := Grid5;
      
   if(Book.ActivePage = T6) then
      Result := Grid6;
      
   if(Book.ActivePage = T7) then
      Result := Grid7;
end;
{**************************************************************************************************}
function  TFrmBlockWeekView.GetCurList: TTimePeriodList;
begin
   Result := NIL;
   
   if(Book.ActivePage = T1) then
      Result := m_TBlockWeekPeriod.Blockings[2];

   if(Book.ActivePage = T2) then
      Result := m_TBlockWeekPeriod.Blockings[3];
      
   if(Book.ActivePage = T3) then
      Result := m_TBlockWeekPeriod.Blockings[4];
      
   if(Book.ActivePage = T4) then
      Result := m_TBlockWeekPeriod.Blockings[5];
      
   if(Book.ActivePage = T5) then
      Result := m_TBlockWeekPeriod.Blockings[6];
      
   if(Book.ActivePage = T6) then
      Result := m_TBlockWeekPeriod.Blockings[7];
      
   if(Book.ActivePage = T7) then
      Result := m_TBlockWeekPeriod.Blockings[1];
end;
{**************************************************************************************************}
procedure TFrmBlockWeekView.DoNew;
var
  aItem   : TTimePeriod;
  aTimeRec: TTimeRec  ;
  aDate1  : TDateTime;
  aDate2  : TDateTime;
begin
   FrmWeekBlockIODialog := TFrmWeekBlockIODialog.Create(Self);
   try
      with TimeRec(now) do begin
         aTimeRec.wHour := wHour;
         aTimeRec.wMin  := 0;
         aTimeRec.wSec  := 0;
      end;
      aDate1 := TimeFromRec(aTimeRec);
      inc(aTimeRec.wSec);
      aDate2 := TimeFromRec(aTimeRec);

      aItem := TTimePeriod.CreateWithParam(aDate1, aDate2, NIL, 'New');
      if(FrmWeekBlockIODialog.Execute(aItem)) then begin
         if(not GetCurList.IsOverlapping(aItem)) then
            GetCurList.Add(aItem)
         else begin
            aItem.Free;
            MessageDlg('The period overlapps an other one.', mtError, [mbOk] ,0);
         end;
      end
      else
         aItem.Free;
   finally
      FrmWeekBlockIODialog.Free;
   end;
   UpdateListsInGrid;
end;
{**************************************************************************************************}
procedure TFrmBlockWeekView.DoEdit;
var
  aItem   : TTimePeriod;
  aTmpItem: TTimePeriod;
begin
   if(GetCurList.Count = 0) then
     Raise Exception.Create('No blockings in this day.');

   aItem := GetCurList.Items[GetCurGrid.Row-1];
   aTmpItem := TTimePeriod.CreateWithObj(aItem);
   GetCurList.Delete(GetCurList.IndexOf(aItem));
   
   aItem := TTimePeriod.CreateWithObj(aTmpItem);
   
   FrmWeekBlockIODialog := TFrmWeekBlockIODialog.Create(Self);
   try
      if(FrmWeekBlockIODialog.Execute(aItem)) then begin
         if(Not GetCurList.IsOverlapping(aItem)) then begin
            GetCurList.Add(aItem);
            aTmpItem.Free;
         end
         else begin
            GetCurList.Add(aTmpItem);
            aItem.Free;
            MessageDlg('The period overlapps an other one.', mtError, [mbOk] ,0);
         end;
      end
      else begin
         GetCurList.Add(aItem);
         aTmpItem.Free;
      end;
   finally
      FrmWeekBlockIODialog.Free;
   end;
   UpdateListsInGrid;
end;
{**************************************************************************************************}
procedure TFrmBlockWeekView.DoDelete;
begin
   if(GetCurList.Count = 0) then
     Raise Exception.Create('No blockings in this day.');

   GetCurList.Delete(GetCurGrid.Row-1);
   UpdateListsInGrid;
end;
{**************************************************************************************************}
{**************************************************************************************************}
{* Dialog for property - editor for TBlockWeekPeriod (Klasse in TWeekPlaning) (END)               *}
{**************************************************************************************************}
procedure TFrmBlockWeekView.AddBtnClick(Sender: TObject);
begin
   DoNew;
end;
{**************************************************************************************************}
procedure TFrmBlockWeekView.EditBtnClick(Sender: TObject);
begin
   DoEdit;
end;
{**************************************************************************************************}
procedure TFrmBlockWeekView.DelBtnClick(Sender: TObject);
begin
   DoDelete;
end;
{**************************************************************************************************}
procedure TFrmBlockWeekView.Add1Click(Sender: TObject);
begin
   DoNew;
end;
{**************************************************************************************************}
procedure TFrmBlockWeekView.Edit1Click(Sender: TObject);
begin
   DoEdit;
end;
{**************************************************************************************************}
procedure TFrmBlockWeekView.Delete1Click(Sender: TObject);
begin
   DoDelete;
end;
{**************************************************************************************************}
procedure TFrmBlockWeekView.Grid6DblClick(Sender: TObject);
begin
   DoEdit;
end;
{**************************************************************************************************}
procedure TFrmBlockWeekView.Grid1DblClick(Sender: TObject);
begin
   DoEdit;
end;
{**************************************************************************************************}
procedure TFrmBlockWeekView.Grid2DblClick(Sender: TObject);
begin
   DoEdit;
end;
{**************************************************************************************************}
procedure TFrmBlockWeekView.Grid3DblClick(Sender: TObject);
begin
   DoEdit;
end;
{**************************************************************************************************}
procedure TFrmBlockWeekView.Grid4DblClick(Sender: TObject);
begin
   DoEdit;
end;
{**************************************************************************************************}
procedure TFrmBlockWeekView.Grid5DblClick(Sender: TObject);
begin
   DoEdit;
end;
{**************************************************************************************************}
procedure TFrmBlockWeekView.Grid7DblClick(Sender: TObject);
begin
   DoEdit;
end;
{**************************************************************************************************}
end. 
